/*
 * Copyright (c) 2020. The Kathra Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Contributors:
 *    IRT SystemX (https://www.kathra.org/)
 *
 */

package org.kathra.sourcemanager;

import org.kathra.utils.security.KeycloakUtils;
import org.kathra.utils.ApiResponse;
import org.kathra.sourcemanager.model.Folder;
import org.kathra.core.model.Membership;
import org.kathra.core.model.SourceRepository;
import org.kathra.core.model.SourceRepositoryCommit;
import java.util.List;
import org.apache.camel.model.dataformat.JsonLibrary;
import org.kathra.KathraAuthRequestHandlerImpl;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.cdi.ContextName;
import org.apache.camel.model.rest.RestBindingMode;
import static org.apache.camel.model.rest.RestParamType.*;

@ContextName("SourceManager")
public class SourceManagerApi extends RouteBuilder {

    @Override
    public void configure() throws Exception {
        KeycloakUtils.init();
        // configure we want to use servlet as the component for the rest DSL
        // and we enable json binding mode
        restConfiguration().component(org.kathra.iface.KathraAuthRequestHandler.HTTP_SERVER)
        // use json binding mode so Camel automatic binds json <--> pojo
        .bindingMode(RestBindingMode.off)
        // and output using pretty print
        .dataFormatProperty("prettyPrint", "true")
        .dataFormatProperty("json.in.disableFeatures", "FAIL_ON_UNKNOWN_PROPERTIES")
        // setup context path on localhost and port number that netty will use
        .contextPath("/api/v1")
        .port("{{env:HTTP_PORT:8080}}")
        .componentProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .endpointProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .consumerProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))

        // add swagger api-doc out of the box
        .apiContextPath("/swagger.json")
        .apiProperty("api.title", "Kathra SourceManager")
        .apiProperty("api.version", "1.0.0")
        .apiProperty("api.description", "SourceManager")
        // and enable CORS
        .apiProperty("cors", "true")
        .enableCORS(true).corsAllowCredentials(true)
        .corsHeaderProperty("Access-Control-Allow-Headers", "Origin, Accept, X-Requested-With, Content-Type," +
                "Access-Control-Request-Method, Access-Control-Request-Headers, Authorization");

        rest()

        .post("/batch/memberships").type(Membership[].class).outType(ApiResponse.class).produces("application/json")
            .description("Add multiple memberships in specified projects")
                .param()
                    .required(true)
                    .name("memberships")
                    .type(body)
                    .description("")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Membership[].class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=addMemberships(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/sourceRepositories/{sourceRepositoryPath}/branches").outType(String.class).produces("application/json")
            .description("Create a new branch in an existing Kathra SourceRepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
                .param()
                    .required(true)
                    .name("branch")
                    .type(body)
                    .description("")
                .endParam()
                .param()
                    .required(false)
                    .dataType("string")
                    .name("branchRef")
                    .type(query)
                    .description("")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=createBranch(${header.sourceRepositoryPath},${body},${header.branchRef})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/sourceRepositories/{sourceRepositoryPath}/branches/{branch}/commits").outType(SourceRepositoryCommit.class).consumes("multipart/form-data").produces("application/json")
            .description("Create new commit in branch")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("branch")
                    .type(path)
                    .description("SourceRepository's branch")
                .endParam()
                .param()
                    .required(true)
                    .dataType("file")
                    .name("file")
                    .type(formData)
                    .description("File to commit")
                .endParam()
                .param()
                    .required(false)
                    .dataType("string")
                    .name("filepath")
                    .type(query)
                    .description("The location in which the file has to be commited")
                .endParam()
                .param()
                    .required(false)
                    .dataType("boolean")
                    .name("uncompress")
                    .type(query)
                    .description("Boolean to indicate if provided file should be uncompressed before being commited")
                .endParam()
                .param()
                    .required(false)
                    .dataType("string")
                    .name("tag")
                    .type(query)
                    .description("Git tag to put on the commit")
                .endParam()
                .param()
                    .required(false)
                    .dataType("boolean")
                    .name("replaceRepositoryContent")
                    .type(query)
                    .description("Boolean to indicate if provided file should replace the whole repository content")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=createCommit(${header.sourceRepositoryPath},${header.branch},${header.file},${header.filepath},${header.uncompress},${header.tag},${header.replaceRepositoryContent})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/sourceRepositories/{sourceRepositoryPath}/deployKeys").outType(ApiResponse.class).produces("application/json")
            .description("Create new deployKey in specified project")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("keyName")
                    .type(query)
                    .description("")
                .endParam()
                .param()
                    .required(true)
                    .name("sshPublicKey")
                    .type(body)
                    .description("")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=createDeployKey(${header.keyName},${body},${header.sourceRepositoryPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/folders").type(Folder.class).outType(Folder.class).produces("application/json")
            .description("Create a new folder in the Source Repository Provider")
                .param()
                    .required(true)
                    .name("folder")
                    .type(body)
                    .description("Folder object")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Folder.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=createFolder(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/sourceRepositories").type(SourceRepository.class).outType(SourceRepository.class).produces("application/json")
            .description("Create a new Source Repository in Kathra Repository Provider")
                .param()
                    .required(true)
                    .name("sourceRepository")
                    .type(body)
                    .description("SourceRepository object to be created")
                .endParam()
                .param()
                    .required(false)
                    .dataType("array")
                    .name("deployKeys")
                    .type(query)
                    .description("A list of deployKey Ids to enable in the created source repository")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,SourceRepository.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=createSourceRepository(${body},${header.deployKeys})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/batch/memberships").type(Membership[].class).outType(ApiResponse.class).produces("application/json")
            .description("Delete multiple memberships in specified projects")
                .param()
                    .required(true)
                    .name("memberships")
                    .type(body)
                    .description("")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Membership[].class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=deleteMemberships(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/sourceRepositories/{sourceRepositoryPath}").outType(String.class).consumes("application/json").produces("application/json")
            .description("Delete Source Repository in Kathra Repository Provider")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=deleteSourceRepository(${header.sourceRepositoryPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/sourceRepositories/{sourceRepositoryPath}/branches").outType(String[].class).consumes("application/json").produces("application/json")
            .description("Retrieve accessible branches in an existing Kathra SourceRepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=getBranches(${header.sourceRepositoryPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/sourceRepositories/{sourceRepositoryPath}/branches/{branch}/commits").outType(SourceRepositoryCommit[].class).consumes("application/json").produces("application/json")
            .description("Retrieve accessible commits in an existing branch")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("branch")
                    .type(path)
                    .description("SourceRepository's branch")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=getCommits(${header.sourceRepositoryPath},${header.branch})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/sourceRepositories/{sourceRepositoryPath}/branches/{branch}/file").consumes("application/json").produces("application/json")
            .description("Retrieve an existing file in an existing branch")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("branch")
                    .type(path)
                    .description("SourceRepository's branch")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("filepath")
                    .type(query)
                    .description("The location of the file to retrieve")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=getFile(${header.sourceRepositoryPath},${header.branch},${header.filepath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
            .endRest()

        .get("/folders/{folderPath}").outType(Folder.class).consumes("application/json").produces("application/json")
            .description("Retrieve specified folder object")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("folderPath")
                    .type(path)
                    .description("Folder's ID in which artifacts will be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=getFolder(${header.folderPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/folders").outType(Folder[].class).consumes("application/json").produces("application/json")
            .description("Retrieve accessible folders for user using provided identity")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=getFolders")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/sourceRepositories/{sourceRepositoryPath}/memberships").outType(Membership[].class).consumes("multipart/form-data").produces("application/json")
            .description("Retrieve memberships in specified project")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryPath")
                    .type(path)
                    .description("SourceRepository's Path")
                .endParam()
                .param()
                    .required(false)
                    .dataType("string")
                    .allowableValues("user","group")
                    .name("memberType")
                    .type(query)
                    .description("Type of memberships to retrieve, return all types if not specified")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=getMemberships(${header.sourceRepositoryPath},${header.memberType})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/folders/{folderPath}/sourceRepositories").outType(SourceRepository[].class).consumes("application/json").produces("application/json")
            .description("Retrieve accessible Source Repositories in the specified folder")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("folderPath")
                    .type(path)
                    .description("Folder's ID in which artifacts will be created")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:SourceManagerController?method=getSourceRepositoriesInFolder(${header.folderPath})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest();
    }
}